# ELK Portal Events

This project is created due to the necessity of easily adding downloaded events from KYPO portal into local ELK instance for further analysis.

## Requirements
Tested with:

| Technology | Version |
| :---: | :---: |
| Docker | 2.2.0.5 |
| Docker Engine | 19.03.8 |
| Docker Compose | 1.25.4 |

### Run and Configure ELK
This script will run and configure ELK.
```
$ sudo docker-compose up
```

Or in the case that you do not want to waste the command line use (NOTE: this case is more difficult for debugging purposes since you won't see easily if any error occurs):
```
$ sudo docker-compose up -d
```

On the successful startup (in approximately 30 seconds, in the case, that you have already downloaded the Elasticsearch, Logstash, Kibana images) you should be able to access those pages in the browser `http://localhost:9200/` and `http://localhost:5601/`:

## Library Usage
Just place the data from selected KYPO event (portal events and bash actions), e.g., `echo - Kobylka 3302`. Then go to the folder with `insert-events.sh` file and run the `insert-events.sh` script as follows (please read the next instructions about file naming convention for audit events):
```
$ ./insert-events.sh "PATH-To-YOUR-KYPO-PORTAL-EVENTS-FOLDER" "PATH-To-YOUR-KYPO-PORTAL-LOGS-DIR"
```

e.g.,

```
$ ./insert-events.sh "/home/seda/kypo-events/echo - Kobylka 3302" "/home/seda/kypo-events/logs_dir"
```

Where the content inside `echo - Kobylka 3302 is` as follows:

![kypo-events-folder](https://gitlab.fi.muni.cz/kypolab/elk-portal-events/-/wikis/uploads/fbebce89ba112084a6ccd9989440f51f/echo_Kobylka_content.PNG)

and `logs_dir` is as follows:

![kypo-bash-history-logs-folder](https://gitlab.fi.muni.cz/kypolab/elk-portal-events/-/wikis/uploads/f81e3ddc1031d847bd94af350e48eba8/logs_dir-content.PNG)

This script basically goes through all the files in the given directories and inside it search for files that match the pattern `*-events.json` or `*-useraction.json` and inserts all the content of those files under the correct index into local Elasticsearch instance running on port 9200.

## Checking the Data in ELK

Visit Kibana user interface ran from the previous step on the page `http://localhost:5601/`. 

You should see page like this:

![kibana-homepage](https://gitlab.fi.muni.cz/kypolab/elk-portal-events/-/wikis/uploads/9c4811b61e9a7144d3f2958fc8d49fcb/kibana-homepage.PNG)

Here, move to `Dev Tools`,

![kibana-devtools](https://gitlab.fi.muni.cz/kypolab/elk-portal-events/-/wikis/uploads/1d9f5afd2ca60784d0494204f9a1a9da/kibana-devtools.PNG)

and add the following command to the `Console`


```
GET kypo*/_search
{
  "size": 10000,
  "query": {
    "match_all": {}
  }
}
```

![kibana-devtools-example](https://gitlab.fi.muni.cz/kypolab/elk-portal-events/-/wikis/uploads/df2930cdefda1429892a78425c796228/kibana-devtools-example.PNG)

and you should see the similar result as is shown above.