#!/bin/bash
ELASTICSEARCH_API_ROOT="http://localhost:9200/"
LOGSTASH_API_ROOT_EVENTS="http://localhost:9602"
LOGSTASH_API_ROOT_BASH="http://localhost:9603"
TEMPLATE_INFO="_template/template_1"
#Set template
curl -H 'Content-Type: application/json' -X PUT -d '{"template":"*","index_patterns":["kypo*"],"mappings":{"default":{"properties":{"timestamp":{"type":"date","format":"epoch_millis"},"start_time":{"type":"date","format":"epoch_millis"},"end_time":{"type":"date","format":"epoch_millis"},"game_time":{"type":"date","format":"epoch_millis"}}}},"settings":{"index.refresh_interval":"5s"}}' ${ELASTICSEARCH_API_ROOT}${TEMPLATE_INFO}?include_type_name=true
## POST data to Elastic search
# KYPO portal events
cd "$1"
for FILE in *-events.json
do
  while read LINE
  do
      LINE=$(echo "$LINE" | sed 's/\\//g' | sed 's/"\[/\[/g' | sed 's/\]"/\]/g')
	  curl -X POST -d "$LINE" "${LOGSTASH_API_ROOT_EVENTS}" -H 'Content-Type: application/json'
  done < $FILE
done
# bash history commands
cd "$2"
for FILE in *-useractions.json
do
  while read -r LINE
  do
	LINE=$(echo "$LINE")
    curl -X POST -d "$LINE" "${LOGSTASH_API_ROOT_BASH}"
  done < $FILE
done
